﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.IO;
using System.Diagnostics;
using System.Threading;
using System.Drawing.Imaging;
using System.Reflection;
using Microsoft.Win32;

namespace CommandosResolutionHack
{
    public partial class frmMain : Form
    {
        [DllImport("user32.dll")]
        public static extern bool EnumDisplaySettings(string deviceName, int modeNum, ref DEVMODE devMode);
        const int ENUM_CURRENT_SETTINGS = -1;
        const int ENUM_REGISTRY_SETTINGS = -2;

        [StructLayout(LayoutKind.Sequential)]
        public struct DEVMODE
        {
            private const int CCHDEVICENAME = 0x20;
            private const int CCHFORMNAME = 0x20;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 0x20)]
            public string dmDeviceName;
            public short dmSpecVersion;
            public short dmDriverVersion;
            public short dmSize;
            public short dmDriverExtra;
            public int dmFields;
            public int dmPositionX;
            public int dmPositionY;
            public ScreenOrientation dmDisplayOrientation;
            public int dmDisplayFixedOutput;
            public short dmColor;
            public short dmDuplex;
            public short dmYResolution;
            public short dmTTOption;
            public short dmCollate;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 0x20)]
            public string dmFormName;
            public short dmLogPixels;
            public int dmBitsPerPel;
            public int dmPelsWidth;
            public int dmPelsHeight;
            public int dmDisplayFlags;
            public int dmDisplayFrequency;
            public int dmICMMethod;
            public int dmICMIntent;
            public int dmMediaType;
            public int dmDitherType;
            public int dmReserved1;
            public int dmReserved2;
            public int dmPanningWidth;
            public int dmPanningHeight;
        }

        public frmMain()
        {
            InitializeComponent();
        }

        enum KNOWN_VERISONS
        {
            GOG,
            GERMAN,
            DEMO,
            SOLDOUT,
            //ULTIMATE
            BTCOD,
            BTCOD_PATCHED,
            RUSSIAN,
            BTCODRUSSIAN,
            SINP_23_EN,
            SINP_23_CN,
            SPANISH,
            SPANISH10,
            BTCODSPANISH
        };
        KNOWN_VERISONS commandosVersion;

        List<String> resolutions = new List<String>();
        byte[] exeBuff;
        string commFile, dirFile, globalFile = "DATOS\\MISIONES\\GLOBAL.STR", workingDir, programDir;

        
        string RES_SEPARATOR = " X ";

        //deprecated... we don't care for these anymore.
        //int RES_512_1 = 0x1a1b9c, RES_512_2 = 0x20175f, RES_512_3 = 0x1BACC5; //and -1, +10, +9 
        //int RES_640_1 = 0x1a1bb8, RES_640_2 = 0x201779, RES_640_3 = 0x1BACDB;
        //int RES_800_1 = 0x1a1bd4, RES_800_2 = 0x201793, RES_800_3 = 0x1BACF1;

        //the single setter for the multiplayer resolution.
        int MULTI_RES = 0x9e5f3;

        //switch list 1 
        // THIS IS THE LAST SLOT IN THE RESOLUTION SWITCH AREA. Find the 4 resolution switch case.
        int? RES_1024_1 = 0x1a1bf0;
        //switch list 2
        // THIS IS THE LOAD SLOT, chances are you'll see a 'pyroscommandos' var load somewhere in the vicinity
        int? RES_1024_2 = 0x2017ad;

        //loading resolution
        int? RES_1024_3 = 0x1BAD07;

        //final checking limit for cfg storage.
        int? RES_1024_4 = 0x1BA80B;

        //1. Search for 74 0C 81 FE 07 14 00 00 74 04. 
        //2. Replace the first two bytes (74 0C) with 90 90 and the last two bytes (74 04) with 90 90. 
        int? LOCALE_FIX_1 = 0x194855;

        //3. Search for 74 0C 81 FF 07 14 00 00 0F 85. 
        //4. Replace the first two bytes (74 0C) with 90 90 and the last two bytes (0F 85) with 90 E9. 
        int? LOCALE_FIX_2 = 0x19971B;

        string WARGAME_FNAME = "WARGAME.DIR";

        bool DIR_EXTRACTED = false;

        private void frmMain_Load(object sender, EventArgs e)
        {
            tbLogging.AppendText("Let's get this started... please note that you can expect a black main menu background...\r\n");
            tbLogging.AppendText("----------------------------------------------------------------------------------------------\r\n");
            tbLogging.AppendText("Waiting for user to select a game exe... please find 'comandos.exe' in your game folder.\r\n");
            programDir = Directory.GetCurrentDirectory();

            this.MaximizeBox = false;
            this.FormBorderStyle = FormBorderStyle.FixedDialog;

            DEVMODE vDevMode = new DEVMODE();
            int i = 0;
            while (EnumDisplaySettings(null, i, ref vDevMode))
            {
                if (!resolutions.Contains(vDevMode.dmPelsWidth + RES_SEPARATOR + vDevMode.dmPelsHeight)
                    && vDevMode.dmPelsWidth > 800)
                {
                    resolutions.Add(vDevMode.dmPelsWidth + RES_SEPARATOR + vDevMode.dmPelsHeight);
                }
                i++;
            }

            tbLogging.AppendText("Possible monitor resolutions (above 800x600):\r\n");
            bool commaAdded = false;
            foreach (string res in resolutions)
            {
                cmb1024.Items.Add(res);
                if (commaAdded) tbLogging.AppendText(", ");
                if (!commaAdded) commaAdded = true;
                tbLogging.AppendText(res);
            }
            tbLogging.AppendText("\r\n----------------------------------------------------------------------------------------------\r\n");

            OpenFileDialog openCommandos = new OpenFileDialog();
            openCommandos.Filter = "Commandos BEL/BTCOD Executable|*.exe";
            openCommandos.Title = "Please select your Commandos BEL/BTCOD Executable";

            if (openCommandos.ShowDialog() == DialogResult.OK)
            {
                commFile = openCommandos.FileName;
                FileStream fs = new FileStream(openCommandos.FileName, FileMode.Open, FileAccess.Read);
                BinaryReader br = new BinaryReader(fs);
                exeBuff = br.ReadBytes((int)new FileInfo(openCommandos.FileName).Length);
                br.Close();
                fs.Close();

                DetermineFileVersion();

                workingDir = openCommandos.FileName.Substring(0, openCommandos.FileName.LastIndexOf('\\') + 1);
                dirFile = workingDir + WARGAME_FNAME;

                if (File.Exists(dirFile)) {
                    if (MessageBox.Show("We found a compressed " + WARGAME_FNAME + ". Do you want to extract it?\r\n" +
                        "NOTE: THIS COULD TAKE QUITE A WHILE! (but is heavily recommended) ...\r\n" +
                        "Extracting this file allows us to update the GUI/GFX to fit new resolutions!",
                        "Compressed " + WARGAME_FNAME + " found!", MessageBoxButtons.YesNo, MessageBoxIcon.Question)
                            == System.Windows.Forms.DialogResult.Yes)
                    {
                        tbLogging.AppendText("Found " + WARGAME_FNAME + "... extracting [this will take a while!]...\r\n");
                        ExportDIR(workingDir, WARGAME_FNAME);
                        File.Move(workingDir + WARGAME_FNAME, workingDir + WARGAME_FNAME + ".BAK");
                        DIR_EXTRACTED = true;
                    }
                    else
                    {
                        tbLogging.AppendText("Not goind to update the GUI!");
                    }
                } else if (File.Exists(workingDir + "DATOS\\MISIONES\\GLOBAL.STR")) {
                    DIR_EXTRACTED = true;
                    dirFile = workingDir + "DATOS\\MISIONES\\GLOBAL.STR";
                    tbLogging.AppendText("Found GLOBAL.STR. " + WARGAME_FNAME + " has already been extracted.\r\n");
                }
                else tbLogging.AppendText("Neither " + WARGAME_FNAME + " or it's contents could be found! Interface wont be updated.\r\n");

                tbLogging.AppendText("----------------------------------------------------------------------------------------------\r\n");

                if (LOCALE_FIX_1 != null)
                {
                    if (exeBuff[(int)LOCALE_FIX_1] == 0x74 && exeBuff[(int)LOCALE_FIX_1 + 1] == 0x0C &&
                        exeBuff[(int)LOCALE_FIX_1 + 8] == 0x74 && exeBuff[(int)LOCALE_FIX_1 + 9] == 0x04)
                        tbLogging.AppendText("Locale patch [1] has not been applied. [Use the checkbox above to apply on next run.]\r\n");
                    else if (exeBuff[(int)LOCALE_FIX_1] == 0x90 && exeBuff[(int)LOCALE_FIX_1 + 1] == 0x90 &&
                        exeBuff[(int)LOCALE_FIX_1 + 8] == 0x90 && exeBuff[(int)LOCALE_FIX_1 + 9] == 0x90)
                    {
                        tbLogging.AppendText("Locale patch [1] has already been applied.\r\n");
                        chkLocale.Checked = true;
                    }
                    else tbLogging.AppendText("Locale [1] bytes in unknown state! (Please apply the local patch above!)\r\n");

                    if (LOCALE_FIX_2 != null)
                    {
                        if (exeBuff[(int)LOCALE_FIX_2] == 0x74 && exeBuff[(int)LOCALE_FIX_2 + 1] == 0x0C &&
                        exeBuff[(int)LOCALE_FIX_2 + 8] == 0x0F && exeBuff[(int)LOCALE_FIX_2 + 9] == 0x85)
                            tbLogging.AppendText("Locale patch [2] has not been applied. [Use the checkbox above to apply on next run.]\r\n");
                        else if (exeBuff[(int)LOCALE_FIX_2] == 0x90 && exeBuff[(int)LOCALE_FIX_2 + 1] == 0x90 &&
                            exeBuff[(int)LOCALE_FIX_2 + 8] == 0x90 && exeBuff[(int)LOCALE_FIX_2 + 9] == 0xE9)
                            tbLogging.AppendText("Locale patch [2] has already been applied.\r\n");
                        else tbLogging.AppendText("Locale [2] bytes in unknown state! (Please apply the local patch above!)\r\n");
                    }
                    else tbLogging.AppendText("Locale patch [2] not required.\r\n");
                }

                tbLogging.AppendText("----------------------------------------------------------------------------------------------\r\n");

                DealWithMultiRes(cmb1024, "Multiplayer", MULTI_RES);
                DealWithRes(cmb1024, "1024" + RES_SEPARATOR + "768", RES_1024_1, RES_1024_2, RES_1024_3, RES_1024_4);

                tbLogging.AppendText("----------------------------------------------------------------------------------------------\r\n");

                //RegistryKey OurKey = Registry.LocalMachine;
                RegistryKey OurKey = RegistryKey.OpenBaseKey(Microsoft.Win32.RegistryHive.CurrentUser, RegistryView.Registry32);
                OurKey = OurKey.OpenSubKey(@"Software\Microsoft\Windows NT\CurrentVersion\AppCompatFlags\Layers", false);
                bool foundCompatMode = false, highDPICorrect = false;
                if (OurKey != null)
                {
                    foreach (string Keyname in OurKey.GetValueNames())
                    {
                        if (commFile.ToLower() == Keyname.ToLower())
                        {
                            //check 
                            var val = OurKey.GetValue(Keyname);
                            foundCompatMode = val.ToString().Contains("WINXPSP3");
                            highDPICorrect = val.ToString().Contains("HIGHDPIAWARE");
                            break;
                        }
                    }
                }
                if (!foundCompatMode || !highDPICorrect)
                {
                    if (!foundCompatMode) tbLogging.AppendText("\r\nWARNING: Compatibility mode is not XPSP3!");
                    if (!highDPICorrect) tbLogging.AppendText("\r\nWARNING: High DPI scaling will distort image!");
                    tbLogging.AppendText("\r\nYou may not be able to set the requested resolution in-game!");
                    tbLogging.AppendText("\r\nTo fix this:");
                    tbLogging.AppendText("\r\n\t1. Browse to " + workingDir);
                    tbLogging.AppendText("\r\n\t2. Right click on " + commFile.Replace(workingDir, "") + " and choose properties");
                    tbLogging.AppendText("\r\n\t3. Switch to the compatibility tab and make sure that WIN XP SP3 is selected.");
                    if (!highDPICorrect)
                        tbLogging.AppendText("\r\n\t4. ALSO MAKE SURE that 'Disable display scaling on high DPI settings' is CHECKED.");
                }
                else
                {
                    tbLogging.AppendText("\r\n\t - Compatibility mode is XPSP3.  [CORRECT]\r\n\t - High DPI scaling is disabled. [CORRECT]");
                }
                tbLogging.AppendText("\r\n\r\n----------------------------------------------------------------------------------------------\r\n");
            }
            else Application.Exit();           
        }

        private static List<int> FileContainsSequence(byte[] source, byte[] value, int offset)
        {
            List<int> locations = new List<int>();
            int found = 0;
            for (int i = 0; i < source.Length; i++)
            {
                if (source[i] == value[found])
                {
                    if (++found == value.Length)
                    {
                        locations.Add(i - value.Length - offset + 1);
                        found = 0;
                    }
                }
                else found = 0;
            }
            return locations;
        }

        private void DetermineFileVersion()
        {
            switch (exeBuff.Length)
            {
                case 2452992:
                    tbLogging.AppendText("Found DEMO version of Commandos...\r\nWe're going to hack the load resolution as well.\r\n");
                    commandosVersion = KNOWN_VERISONS.DEMO;
                    break;
                case 2469376:
                    //could be spanish or german!
                    if (exeBuff[0x88] == 0xd3 && exeBuff[0x89] == 0xd0)
                    {
                        tbLogging.AppendText("Found GERMAN version of Commandos\r\n");
                        commandosVersion = KNOWN_VERISONS.GERMAN;
                    }
                    else if (exeBuff[0x88] == 0x1e && exeBuff[0x89] == 0xd1)
                    {
                        tbLogging.AppendText("Found Spanish version of Commandos\r\n");
                        commandosVersion = KNOWN_VERISONS.SPANISH;
                    }
                    break;
                case 2969600:
                    tbLogging.AppendText("Found Commandos - Beyond the Call of Duty (SPANISH)\r\n");
                    commandosVersion = KNOWN_VERISONS.BTCODSPANISH;
                    WARGAME_FNAME = "WAR_MP.DIR";
                    break;
                case 2479104:
                    tbLogging.AppendText("Found 'Sold Out' v1.1 version of Commandos\r\n");
                    commandosVersion = KNOWN_VERISONS.SOLDOUT;
                    break;
                case 3715072:
                    tbLogging.AppendText("Found 'GOG.com Ammo Pack version'/'Commandos Ultimate Fix' version of Commandos\r\n");
                    commandosVersion = KNOWN_VERISONS.GOG;
                    break;
                    //ultimate 3715072
                case 3133440:
                    tbLogging.AppendText("Found Commandos - Beyond the Call of Duty\r\n");
                    commandosVersion = KNOWN_VERISONS.BTCOD;
                    WARGAME_FNAME = "WAR_MP.DIR";
                    break;
                case 2470400:
                    tbLogging.AppendText("Found the Russian version of Commandos - BEL\r\n");
                    commandosVersion = KNOWN_VERISONS.RUSSIAN;
                    WARGAME_FNAME = "WAR_MP.DIR";
                    break;
                case 2968576:
                    tbLogging.AppendText("Found Commandos - Beyond the Call of Duty (RUSSIAN)\r\n");
                    commandosVersion = KNOWN_VERISONS.BTCODRUSSIAN;
                    WARGAME_FNAME = "WAR_MP.DIR";
                    break;
                case 2482688:
                    tbLogging.AppendText("Found SINP 2.3 English Commandos... we hope?\r\n");
                    commandosVersion = KNOWN_VERISONS.SINP_23_EN;
                    break;
                case 2313216:
                    tbLogging.AppendText("Found SINP 2.3 Chinese Commandos... we hope?\r\n");
                    commandosVersion = KNOWN_VERISONS.SINP_23_CN;
                    break;
                case 2469888:
                    tbLogging.AppendText("Found Spanish 1.0 Commandos...\r\n");
                    commandosVersion = KNOWN_VERISONS.SPANISH10;
                    break;
                default:
                    MessageBox.Show("Found an unknown version of Commandos!\r\n" +
                        "Size: " + exeBuff.Length + " bytes\r\n" +
                        "Please report this at http://modelrail.otenko.com/ (Search for the commandos blog post)",
                        "Error: Cannot continue", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    this.Close();
                    break;
            }

            //find 'SetResolution'
            //53 56 57 8B F1 55 33 FF 66 8B 78 28
            /* WE don't care anymore... hardcoded values per known exe.
            List<int> appearances = FileContainsSequence(exeBuff, new byte[] { 
                                            0x53, 0x56, 0x57, 0x8B, 0xF1, 
                                            0x55, 0x33, 0xFF, 0x66, 0x8B, 0x78, 0x28 }, 11);
            if (appearances.Count > 0)
            {
                if (appearances.Count != 1)
                {
                    MessageBox.Show("Error, the 'SetResolution' search reported " + appearances + "entries... We only wanted 1.\r\n" +
                        "Please report this at http://modelrail.otenko.com/ (Search for the Commandos blog post)", 
                        "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    Application.Exit();
                }
            }
            else
            {
                MessageBox.Show("Error, the 'SetResolution' search reported zero entries... We needed at least 1.\r\n" + 
                    "Please report this at http://modelrail.otenko.com/ (Search for the Commandos blog post)", 
                        "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                Application.Exit();
            }
            */
            //find the multiplayer location:
            switch (commandosVersion)
            {
                case KNOWN_VERISONS.GOG:
                    //default
                    break;
                case KNOWN_VERISONS.SPANISH:
                    MULTI_RES = 0x16739D;
                    RES_1024_1 = 0xf56cc;
                    RES_1024_2 = 0x1854d;
                    RES_1024_3 = 0x1b5c11;
                    RES_1024_4 = null;
                    LOCALE_FIX_1 = 0xcdbd5;
                    LOCALE_FIX_2 = null;
                    break;
                case KNOWN_VERISONS.SPANISH10:
                    MULTI_RES = 0x16767D;
                    RES_1024_1 = 0xF598C;
                    RES_1024_2 = 0x1855D;
                    RES_1024_3 = 0x1b5f41;
                    RES_1024_4 = null;
                    LOCALE_FIX_1 = 0xcdff5;
                    LOCALE_FIX_2 = null;
                    break;
                case KNOWN_VERISONS.GERMAN:
                    MULTI_RES = 0x10FBBD;
                    RES_1024_1 = 0xA62BC;
                    RES_1024_2 = 0xB806D;
                    RES_1024_3 = 0x1ae251;
                    RES_1024_4 = null;
                    LOCALE_FIX_1 = 0x4BE45;
                    LOCALE_FIX_2 = null;
                    break;
                case KNOWN_VERISONS.DEMO:
                    MULTI_RES = 0x163C3D;
                    RES_1024_1 = 0xF302C;
                    RES_1024_2 = 0x18A6D;
                    RES_1024_3 = 0x1b0ec1;
                    RES_1024_4 = null;
                    LOCALE_FIX_1 = 0xCBA85;
                    LOCALE_FIX_2 = null; //doesn't exist.
                    break;
                case KNOWN_VERISONS.SOLDOUT:
                    MULTI_RES = 0x110BBD;
                    RES_1024_1 = 0xA6DEC;
                    RES_1024_2 = 0xB8C0D;
                    RES_1024_3 = 0x15F3C9;
                    RES_1024_4 = 0x15FA64;
                    LOCALE_FIX_1 = 0x4C465;
                    LOCALE_FIX_2 = null;
                    break;
                case KNOWN_VERISONS.BTCOD:
                    MULTI_RES = 0x129632;
                    RES_1024_1 = 0x14c073;
                    RES_1024_2 = 0x1f3BEd;
                    RES_1024_3 = 0x15d4b8;
                    RES_1024_4 = 0x15cFAC;
                    LOCALE_FIX_1 = 0x11FA25;
                    LOCALE_FIX_2 = 0x124a98;
                    break;
                case KNOWN_VERISONS.BTCODSPANISH:
                    MULTI_RES = 0x14651e;
                    LOCALE_FIX_1 = 0x140325;
                    LOCALE_FIX_2 = 0x13b020;
                    RES_1024_1 = 0x2289dd;
                    RES_1024_2 = 0x169265;
                    RES_1024_3 = 0x1788cf;
                    RES_1024_4 = 0x1795f2;
                    break;
                case KNOWN_VERISONS.RUSSIAN:
                    MULTI_RES = 0x10fdfd;
                    RES_1024_1 = 0xa64bc;
                    RES_1024_2 = 0xb827d;
                    RES_1024_3 = 0x15da99;
                    RES_1024_4 = 0x15e074;
                    LOCALE_FIX_1 = 0x4beb5;
                    LOCALE_FIX_2 = null;
                    break;
                case KNOWN_VERISONS.BTCODRUSSIAN:
                    MULTI_RES = 0x14618e;
                    RES_1024_1 = 0x168ed5;
                    RES_1024_2 = 0x22864d;
                    RES_1024_3 = 0x17853f;
                    RES_1024_4 = 0x179262;
                    LOCALE_FIX_1 = 0x13ffb1;
                    LOCALE_FIX_2 = 0x13acb0;
                    break;
                case KNOWN_VERISONS.SINP_23_EN:
                    MULTI_RES = 0x110bbd;
                    RES_1024_1 = 0xB8C0d;
                    RES_1024_2 = 0xa6dec;
                    RES_1024_3 = 0x15f3c9;
                    RES_1024_4 = 0x15fa64;
                    LOCALE_FIX_1 = 0x04c465;
                    LOCALE_FIX_2 = null;
                    break;
                case KNOWN_VERISONS.SINP_23_CN:
                    MULTI_RES = 0x16621d;
                    RES_1024_1 = 0x18edd;
                    RES_1024_2 = 0x151e60;
                    RES_1024_4 = 0xf479c;
                    RES_1024_3 = 0x1b4a51;//0x149649;//0xf472d;//0xe4859;//0xca915;//0xbd153;//0x5be6c;//0x043fef;
                    LOCALE_FIX_1 = 0x0CCDE5;
                    LOCALE_FIX_2 = null;
                    break;
            }
        }

        private void DealWithMultiRes(ComboBox cmb, string res, int? firstStart)
        {
            string resFound = "Searching for " + res + " settings: ";
            int multiX = (exeBuff[(int)firstStart] << 8) | exeBuff[(int)firstStart - 1];
            int multiY = (exeBuff[(int)firstStart - 5] << 8) | exeBuff[(int)firstStart - 6];
            if (commandosVersion == KNOWN_VERISONS.BTCOD)
            {
                multiY = (exeBuff[(int)firstStart - 11] << 8) | exeBuff[(int)firstStart - 12];
            }
            if (cmb.SelectedIndex == -1) cmb.SelectedIndex = cmb.Items.IndexOf(multiX + RES_SEPARATOR + multiY);
            tbLogging.AppendText(resFound + multiX + RES_SEPARATOR + multiY + "\r\n");
        }

        private void DealWithRes(ComboBox cmb, string res,  int? firstStart, int? secondStart, int? thirdStart, int? fourthStart) {
            string resFound = "Searching for " + res + " settings: ";
            bool mismatch = false;
            int multiX = (exeBuff[(int)firstStart] << 8) | exeBuff[(int)firstStart - 1];
            int multiY = (exeBuff[(int)firstStart - 5] << 8) | exeBuff[(int)firstStart - 6];
            if (cmb.SelectedIndex == -1) cmb.SelectedIndex = cmb.Items.IndexOf(multiX + RES_SEPARATOR + multiY);
            resFound += multiX + RES_SEPARATOR + multiY;
            if (secondStart != null)
            {
                int otherX = ((exeBuff[(int)secondStart] << 8) | exeBuff[(int)secondStart - 1]);
                int otherY = ((exeBuff[(int)secondStart - 5] << 8) | exeBuff[(int)secondStart - 6]);
                if (multiX != otherX || multiY != otherY) {
                    resFound += ", !! " + otherX + RES_SEPARATOR + otherY;
                    mismatch = true;
                }
                else resFound += ", " + otherX + RES_SEPARATOR + otherY;
            }
            if (thirdStart != null && (commandosVersion != KNOWN_VERISONS.DEMO && 
                commandosVersion != KNOWN_VERISONS.SPANISH &&
                commandosVersion != KNOWN_VERISONS.GERMAN &&
                commandosVersion != KNOWN_VERISONS.SPANISH10 && 
                commandosVersion != KNOWN_VERISONS.SINP_23_CN))
            {
                int otherX = ((exeBuff[(int)thirdStart] << 8) | exeBuff[(int)thirdStart - 1]);
                int otherY = ((exeBuff[(int)thirdStart + 10] << 8) | exeBuff[(int)thirdStart + 9]);
                if (multiX != otherX || multiY != otherY)
                {
                    resFound += ", !! " + otherX + RES_SEPARATOR + otherY;
                    mismatch = true;
                }
                else resFound += ", " + otherX + RES_SEPARATOR + otherY;
            }
            else if (thirdStart != null && (commandosVersion == KNOWN_VERISONS.DEMO || 
                commandosVersion == KNOWN_VERISONS.SPANISH ||
                commandosVersion == KNOWN_VERISONS.GERMAN ||
                commandosVersion == KNOWN_VERISONS.SPANISH10 || 
                commandosVersion == KNOWN_VERISONS.SINP_23_CN))
            {
                int otherX = ((exeBuff[(int)thirdStart] << 8) | exeBuff[(int)thirdStart - 1]);
                int otherY = ((exeBuff[(int)thirdStart - 5] << 8) | exeBuff[(int)thirdStart - 6]);
                if (multiX != otherX || multiY != otherY) {
                    resFound += ", !! " + otherX + RES_SEPARATOR + otherY;
                    mismatch = true;
                }
                else resFound += ", " + otherX + RES_SEPARATOR + otherY;
            }
            if (fourthStart != null)
            {
                int otherX = ((exeBuff[(int)fourthStart] << 8) | exeBuff[(int)fourthStart - 1]);
                if (multiX != otherX)
                {
                    resFound += ", !! " + otherX + RES_SEPARATOR + multiY;
                    mismatch = true;
                }
                else resFound += ", " + otherX + RES_SEPARATOR + multiY ;
            }
            tbLogging.AppendText(resFound + "\r\n");
            if (mismatch)
            {
                tbLogging.AppendText("----------------------------------------------------------------------------------------------\r\n");
                tbLogging.AppendText("Note that there was a mismatch found above.\r\n");
                tbLogging.AppendText("This means that, for some reason, the resolutions for a single setting weren't aligned.\r\n");
                tbLogging.AppendText("This will be fixed the next time you apply this hack to this Commandos executable.\r\n");
            }
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void btnApplyAndRun_Click(object sender, EventArgs e)
        {
            tbLogging.AppendText("...hacking...\r\n");

            RewriteMultiResolution(cmb1024);
            RewriteResolution(cmb1024, RES_1024_1, RES_1024_2, RES_1024_3, RES_1024_4);

            if (chkLocale.Checked)
            {
                if (LOCALE_FIX_1 != null)
                {
                    exeBuff[(int)LOCALE_FIX_1] = 0x90;
                    exeBuff[(int)LOCALE_FIX_1 + 1] = 0x90;
                    exeBuff[(int)LOCALE_FIX_1 + 8] = 0x90;
                    exeBuff[(int)LOCALE_FIX_1 + 9] = 0x90;
                }
                if (LOCALE_FIX_2 != null)
                {
                    exeBuff[(int)LOCALE_FIX_2] = 0x90;
                    exeBuff[(int)LOCALE_FIX_2 + 1] = 0x90;
                    exeBuff[(int)LOCALE_FIX_2 + 8] = 0x90;
                    exeBuff[(int)LOCALE_FIX_2 + 9] = 0xE9;
                }
            }

            //final hack... we need to make BTCOD not check the current screen size, it's a stupid idea :)
            //we may want a higher res than the current screen?

            if (commandosVersion == KNOWN_VERISONS.BTCOD)
            {
                exeBuff[0x1D0D2D] = 0x90; //skip BPP match
                exeBuff[0x1D0D2E] = 0x90;
                exeBuff[0x1D0D3A] = 0x90; //skip vert res check
                exeBuff[0x1D0D3B] = 0x90;
                exeBuff[0x1D0D47] = 0x90; //skip hor res check
                exeBuff[0x1D0D48] = 0x90;
            }

            try
            {
                //copy a backup
                File.Copy(commFile, commFile + ".bak", true);

                //write out the new exe.
                FileStream fs = new FileStream(commFile, FileMode.Create, FileAccess.ReadWrite);
                BinaryWriter bw = new BinaryWriter(fs);
                bw.Write(exeBuff);
                bw.Close();

                if (DIR_EXTRACTED)
                {
                    //write the string to the menu
                    WriteMenuResolution();

                    //and then make sure we have a background image
                    CopyBackgroundImage();
                }

                //start the game.
                StartCommandos();
            }
            catch (Exception ex)
            {
                MessageBox.Show("Could not edit the EXE (Are you Administrator?), is it open elsewhere?\r\n" + ex.Message, "ERROR!", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }

        }

        private void CopyBackgroundImage()
        {
            string fname = "\\MENU" + cmb1024.Text.Split(' ').FirstOrDefault() + ".BMP";
            string output = workingDir + "DATOS\\RECURSOS\\BMPS\\SYSTEM\\MISC\\" + fname;

            if (File.Exists(output)) File.Delete(output);
            
            Assembly assembly = Assembly.GetExecutingAssembly();
            Stream file = assembly.GetManifestResourceStream("CommandosResolutionHack.Resources.MENU.bmp");
            using (BinaryReader bReader = new BinaryReader(file))
            {
                using (FileStream fStream = new FileStream(output, FileMode.Create))
                {
                    using (BinaryWriter bWriter = new BinaryWriter(fStream))
                    {
                        bWriter.Write(bReader.ReadBytes((int)file.Length));
                        bReader.Close();
                    }
                }
            }
        }

        private void WriteMenuResolution()
        {
            FileStream fs = new FileStream(workingDir + globalFile, FileMode.Open, FileAccess.Read);
            StreamReader sr = new StreamReader(fs, Encoding.GetEncoding(1252), false);
            Encoding enc = sr.CurrentEncoding;
            string contents = sr.ReadToEnd();
            sr.Close();
            fs.Close();

            int start = contents.IndexOf("OVI4");
            string substr = contents.Substring(start, contents.IndexOf('\n', start) + 1 - start);
            contents = contents.Replace(substr, "OVI4 " + cmb1024.Text + "\r\n");

            fs = new FileStream(workingDir + globalFile, FileMode.Create, FileAccess.Write);
            StreamWriter sw = new StreamWriter(fs, enc);
            sw.Write(contents);
            sw.Close();
            fs.Close();
        }

        private void RewriteMultiResolution(ComboBox cmb)
        {
            byte[] multiX = BitConverter.GetBytes(int.Parse(cmb.Text.Split('X')[0].Trim()));
            byte[] multiY = BitConverter.GetBytes(int.Parse(cmb.Text.Split('X')[1].Trim()));

            if (commandosVersion == KNOWN_VERISONS.BTCOD)
            {
                //CPU Disasm
                //Address   Hex dump               Command                                  Comments
                //00529623  |> \6A 10              PUSH 10                                  ; /Arg3 = 10
                //00529625  |.  68 E0 01 00 00     PUSH 1E0                                 ; |Arg2 = 1E0
                //0052962A  |.  89 8E 30 14 00 00  MOV DWORD PTR DS:[ESI+1430],ECX          ; |
                //00529630  |.  68 80 02 00 00     PUSH 280                                 ; |Arg1 = 280

                exeBuff[(int)MULTI_RES] = multiX[1];
                exeBuff[(int)MULTI_RES - 1] = multiX[0];
                exeBuff[(int)MULTI_RES - 11] = multiY[1];
                exeBuff[(int)MULTI_RES - 12] = multiY[0];
            }
            else
            {
                exeBuff[(int)MULTI_RES] = multiX[1];
                exeBuff[(int)MULTI_RES - 1] = multiX[0];
                exeBuff[(int)MULTI_RES - 5] = multiY[1];
                exeBuff[(int)MULTI_RES - 6] = multiY[0];
            }
        }

        private void RewriteResolution(ComboBox cmb, int? first, int? second, int? third, int? fourth)
        {
            byte[] multiX = BitConverter.GetBytes(int.Parse(cmb.Text.Split('X')[0].Trim()));
            byte[] multiY = BitConverter.GetBytes(int.Parse(cmb.Text.Split('X')[1].Trim()));

            if (first != null)
            {
                exeBuff[(int)first] = multiX[1];
                exeBuff[(int)first - 1] = multiX[0];
                exeBuff[(int)first - 5] = multiY[1];
                exeBuff[(int)first - 6] = multiY[0];
            }
            if (second != null)
            {
                exeBuff[(int)second] = multiX[1];
                exeBuff[(int)second - 1] = multiX[0];
                exeBuff[(int)second - 5] = multiY[1];
                exeBuff[(int)second - 6] = multiY[0];
            }
            if (third != null && (commandosVersion != KNOWN_VERISONS.DEMO &&
                commandosVersion != KNOWN_VERISONS.SPANISH &&
                commandosVersion != KNOWN_VERISONS.SPANISH10 &&
                commandosVersion != KNOWN_VERISONS.GERMAN && 
                commandosVersion != KNOWN_VERISONS.SINP_23_CN))
            {
                exeBuff[(int)third] = multiX[1];
                exeBuff[(int)third - 1] = multiX[0];
                exeBuff[(int)third + 10] = multiY[1];
                exeBuff[(int)third + 9] = multiY[0];
            }
            else if (third != null && (commandosVersion == KNOWN_VERISONS.DEMO ||
                commandosVersion == KNOWN_VERISONS.SPANISH ||
                commandosVersion == KNOWN_VERISONS.SPANISH10 || 
                commandosVersion == KNOWN_VERISONS.GERMAN || 
                commandosVersion == KNOWN_VERISONS.SINP_23_CN))
            {
                exeBuff[(int)third] = multiX[1];
                exeBuff[(int)third - 1] = multiX[0];
                exeBuff[(int)third - 5] = multiY[1];
                exeBuff[(int)third - 6] = multiY[0];
            }
            if (fourth != null)
            {
                exeBuff[(int)fourth] = multiX[1];
                exeBuff[(int)fourth - 1] = multiX[0];
            }
        }

        private void StartCommandos()
        {
            ProcessStartInfo _processStartInfo = new ProcessStartInfo();
            _processStartInfo.WorkingDirectory = workingDir;
            _processStartInfo.FileName = commFile;
            Process myProc = Process.Start(_processStartInfo);
            Application.Exit();
        }

        private void cmdRun_Click(object sender, EventArgs e)
        {
            StartCommandos();
        }

        private void ExportDIR(string dir, string fname)
        {
            FileStream fs = new FileStream(dir + fname, FileMode.Open, FileAccess.Read);
            BinaryReader br = new BinaryReader(fs);
            byte[] bytes = br.ReadBytes((int)new FileInfo(dir + fname).Length);
            br.Close();
            fs.Close();

            int curPos = 0;
            DIR_ITEM root = iterateDIR(dir, bytes, ref curPos);
            tbLogging.AppendText("...COMPLETED.\r\n");
        }

        private struct DIR_ITEM
        {
            public string itemName;
            public int itemType;
            public int itemSize;
            public int itemOffset;
            public List<DIR_ITEM> children;
        }

        private DIR_ITEM iterateDIR(string path, byte[] dir, ref int curPos)
        {
            DIR_ITEM temp = new DIR_ITEM();
            temp.itemName = Encoding.ASCII.GetString(dir, curPos, 32); curPos += 32;
            temp.itemName = temp.itemName.Substring(0, temp.itemName.IndexOf('\0'));
            temp.itemType = dir[curPos]; curPos += 4;
            temp.itemSize = dir[curPos] | dir[curPos + 1] << 8 | dir[curPos + 2] << 16 | dir[curPos + 3] << 24; curPos += 4;
            temp.itemOffset = dir[curPos] | dir[curPos + 1] << 8 | dir[curPos + 2] << 16 | dir[curPos + 3] << 24; curPos += 4;
            if (temp.itemType != 0xff && temp.itemType != 1)
            {
                if (!File.Exists(path + temp.itemName))
                {
                    FileStream fs = new FileStream(path + temp.itemName, FileMode.Create, FileAccess.Write);
                    BinaryWriter wr = new BinaryWriter(fs);
                    //really slow you are, linq!
                    //wr.Write(dir.Skip(temp.itemOffset).Take(temp.itemSize).ToArray());
                    wr.Write(dir, temp.itemOffset, temp.itemSize);
                    wr.Close();
                    fs.Close();
                    tbLogging.AppendText("Extracted " + path + temp.itemName + "\r\n");
                    this.Update();
                }
            } 
            else  if (temp.itemType == 1)
            {
                if (!Directory.Exists(path + temp.itemName))
                {
                    Directory.CreateDirectory(path + temp.itemName);
                    tbLogging.AppendText("Created Folder " + path + temp.itemName + "\r\n");
                    this.Update();
                }
                temp.children = new List<DIR_ITEM>();
                int pos = curPos;
                curPos = temp.itemOffset;
                path += temp.itemName + "\\";
                DIR_ITEM child = iterateDIR(path, dir, ref curPos);
                while (child.itemType != 0xff) {
                    temp.children.Add(child);
                    child = iterateDIR(path, dir, ref curPos);
                }
                curPos = pos;
            }
            return temp;
        }

        private void cmb1024_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = true;
        }
    }
}
